Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7989)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 7990)
@@ -5,11 +5,12 @@
    !!                 Richardson number dependent formulation
    !!======================================================================
-   !! History :  OPA  ! 1987-09  (P. Andrich)  Original code
-   !!            4.0  ! 1991-11  (G. Madec)
-   !!            7.0  ! 1996-01  (G. Madec)  complete rewriting of multitasking suppression of common work arrays
-   !!            8.0  ! 1997-06  (G. Madec)  complete rewriting of zdfmix
-   !!   NEMO     1.0  ! 2002-06  (G. Madec)  F90: Free form and module
-   !!            3.3  ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
-   !!            3.3.1! 2011-09  (P. Oddo) Mixed layer depth parameterization
+   !! History :  OPA  !  1987-09  (P. Andrich)  Original code
+   !!            4.0  !  1991-11  (G. Madec)
+   !!            7.0  !  1996-01  (G. Madec)  complete rewriting of multitasking suppression of common work arrays
+   !!            8.0  !  1997-06  (G. Madec)  complete rewriting of zdfmix
+   !!   NEMO     1.0  !  2002-06  (G. Madec)  F90: Free form and module
+   !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
+   !!            3.3.1!  2011-09  (P. Oddo) Mixed layer depth parameterization
+   !!            4.0  !  2017-04  (G. Madec)  remove CPP ddm key & avm at t-point only 
    !!----------------------------------------------------------------------
 
@@ -21,12 +22,14 @@
    USE dom_oce        ! ocean space and time domain variables
    USE zdf_oce        ! ocean vertical physics
+   USE phycst         ! physical constants
+   USE sbc_oce,  ONLY :   taum
+   USE eosbn2 ,  ONLY :   neos
+   !
    USE in_out_manager ! I/O manager
    USE lbclnk         ! ocean lateral boundary condition (or mpp link)
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! work arrays
    USE timing         ! Timing
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
-   USE eosbn2, ONLY : neos
 
    IMPLICIT NONE
@@ -36,16 +39,14 @@
    PUBLIC   zdf_ric_init    ! called by opa.F90
 
-   !                           !!* Namelist namzdf_ric : Richardson number dependent Kz *
-   INTEGER  ::   nn_ric         ! coefficient of the parameterization
-   REAL(wp) ::   rn_avmri       ! maximum value of the vertical eddy viscosity
-   REAL(wp) ::   rn_alp         ! coefficient of the parameterization
-   REAL(wp) ::   rn_ekmfc       ! Ekman Factor Coeff
-   REAL(wp) ::   rn_mldmin      ! minimum mixed layer (ML) depth    
-   REAL(wp) ::   rn_mldmax      ! maximum mixed layer depth
-   REAL(wp) ::   rn_wtmix       ! Vertical eddy Diff. in the ML
-   REAL(wp) ::   rn_wvmix       ! Vertical eddy Visc. in the ML
-   LOGICAL  ::   ln_mldw        ! Use or not the MLD parameters
-
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tmric   !: coef. for the horizontal mean at t-point
+   !                        !!* Namelist namzdf_ric : Richardson number dependent Kz *
+   INTEGER  ::   nn_ric      ! coefficient of the parameterization
+   REAL(wp) ::   rn_avmri    ! maximum value of the vertical eddy viscosity
+   REAL(wp) ::   rn_alp      ! coefficient of the parameterization
+   REAL(wp) ::   rn_ekmfc    ! Ekman Factor Coeff
+   REAL(wp) ::   rn_mldmin   ! minimum mixed layer (ML) depth    
+   REAL(wp) ::   rn_mldmax   ! maximum mixed layer depth
+   REAL(wp) ::   rn_wtmix    ! Vertical eddy Diff. in the ML
+   REAL(wp) ::   rn_wvmix    ! Vertical eddy Visc. in the ML
+   LOGICAL  ::   ln_mldw     ! Use or not the MLD parameters
 
    !! * Substitutions
@@ -57,15 +58,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
-   INTEGER FUNCTION zdf_ric_alloc()
-      !!----------------------------------------------------------------------
-      !!                 ***  FUNCTION zdf_ric_alloc  ***
-      !!----------------------------------------------------------------------
-      ALLOCATE( tmric(jpi,jpj,jpk)   , STAT= zdf_ric_alloc )
-      !
-      IF( lk_mpp             )   CALL mpp_sum ( zdf_ric_alloc )
-      IF( zdf_ric_alloc /= 0 )   CALL ctl_warn('zdf_ric_alloc: failed to allocate arrays')
-   END FUNCTION zdf_ric_alloc
-
 
    SUBROUTINE zdf_ric( kt )
@@ -105,126 +95,96 @@
       !!      and bottom value already set in zdfphy.F90
       !!
+      !! ** Action  :   avm, avt  mixing coeff (inner domain values only)
+      !!
       !! References : Pacanowski & Philander 1981, JPO, 1441-1451.
       !!              PFJ Lermusiaux 2001.
       !!----------------------------------------------------------------------
-      USE phycst,   ONLY:   rsmall,rau0
-      USE sbc_oce,  ONLY:   taum
-      !!
-      INTEGER, INTENT( in ) ::   kt                           ! ocean time-step
-      !!
-      INTEGER  ::   ji, jj, jk                                ! dummy loop indices
-      REAL(wp) ::   zcoef, zdku, zdkv, zri, z05alp, zflageos  ! temporary scalars
-      REAL(wp) ::   zrhos, zustar
-      REAL(wp), POINTER, DIMENSION(:,:) ::   zwx, ekm_dep  
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('zdf_ric')
-      !
-      CALL wrk_alloc( jpi,jpj, zwx, ekm_dep )
-      !                                                ! ===============
-      DO jk = 2, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-         ! Richardson number (put in zwx(ji,jj))
-         ! -----------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step
+      !!
+      INTEGER  ::   ji, jj, jk                 ! dummy loop indices
+      LOGICAL  ::   ll_av_weight = .TRUE.      ! local logical
+      REAL(wp) ::   zsh2, zcfRi, zav, zustar   ! local scalars
+      REAL(wp), DIMENSION(jpi,jpj) ::   zdu2, zdv2, zh_ekm   ! 2D workspace
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )   CALL timing_start('zdf_ric')
+      !
+      DO jk = 2, jpkm1        !==  avm and avt = F(Richardson number)  ==!
+         !
+      IF( ll_av_weight ) THEN    !== viscosity weighted shear & stratification terms
+         !
+         DO jj = 1, jpjm1           !* viscosity weighted shear term
+            DO ji = 1, jpim1
+               zdu2(ji,jj) = 0.5 * ( avm(ji,jj,jk  ) + avm(ji+1,jj,jk) ) * wumask(ji,jj,jk)      &
+                  &              * (  un(ji,jj,jk-1) -  un(ji  ,jj,jk) )                         &
+                  &              * (  ub(ji,jj,jk-1) -  ub(ji  ,jj,jk) ) / (  e3uw_n(ji,jj,jk) * e3uw_b(ji,jj,jk) )
+               zdv2(ji,jj) = 0.5 * ( avm(ji,jj,jk  ) + avm(ji,jj+1,jk) ) * wumask(ji,jj,jk)      &
+                  &              * (  vn(ji,jj,jk-1) -  vn(ji,jj  ,jk) )                         &
+                  &              * (  vb(ji,jj,jk-1) -  vb(ji,jj  ,jk) ) / (  e3vw_n(ji,jj,jk) * e3vw_b(ji,jj,jk) )
+            END DO
+         END DO
          DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-               zcoef = 0.5 / e3w_n(ji,jj,jk)
-               !                                            ! shear of horizontal velocity
-               zdku = zcoef * (  ub(ji-1,jj,jk-1) + ub(ji,jj,jk-1)   &
-                  &             -ub(ji-1,jj,jk  ) - ub(ji,jj,jk  )  )
-               zdkv = zcoef * (  vb(ji,jj-1,jk-1) + vb(ji,jj,jk-1)   &
-                  &             -vb(ji,jj-1,jk  ) - vb(ji,jj,jk  )  )
-               !                                            ! richardson number (minimum value set to zero)
-               zri = rn2(ji,jj,jk) / ( zdku*zdku + zdkv*zdkv + 1.e-20 )
-               zwx(ji,jj) = MAX( zri, 0.e0 )
-            END DO
-         END DO
-         CALL lbc_lnk( zwx, 'W', 1. )                       ! Boundary condition   (sign unchanged)
-
-         ! Vertical eddy viscosity and diffusivity coefficients
-         ! -------------------------------------------------------
-         z05alp = 0.5_wp * rn_alp
-         DO jj = 1, jpjm1                                   ! Eddy viscosity coefficients (avm)
-            DO ji = 1, fs_jpim1
-               avmu(ji,jj,jk) = umask(ji,jj,jk) * rn_avmri / ( 1. + z05alp*( zwx(ji+1,jj)+zwx(ji,jj) ) )**nn_ric
-               avmv(ji,jj,jk) = vmask(ji,jj,jk) * rn_avmri / ( 1. + z05alp*( zwx(ji,jj+1)+zwx(ji,jj) ) )**nn_ric
-            END DO
-         END DO
-         DO jj = 2, jpjm1                                   ! Eddy diffusivity coefficients (avt)
-            DO ji = fs_2, fs_jpim1
-               avt(ji,jj,jk) = tmric(ji,jj,jk) / ( 1._wp + rn_alp * zwx(ji,jj) )           &
-                  &                            * (  avmu(ji,jj,jk) + avmu(ji-1,jj,jk)      &
-                  &                               + avmv(ji,jj,jk) + avmv(ji,jj-1,jk)  )   &
-                  &          + avtb(jk) * tmask(ji,jj,jk)
-            END DO
-         END DO
-         DO jj = 2, jpjm1                                   ! Add the background coefficient on eddy viscosity
-            DO ji = fs_2, fs_jpim1
-               avmu(ji,jj,jk) = avmu(ji,jj,jk) + avmb(jk) * umask(ji,jj,jk)
-               avmv(ji,jj,jk) = avmv(ji,jj,jk) + avmb(jk) * vmask(ji,jj,jk)
-            END DO
-         END DO
-         !                                             ! ===============
-      END DO                                           !   End of slab
-      !                                                ! ===============
-      !
-      IF( ln_mldw ) THEN
-
-      !  Compute Ekman depth from wind stress forcing.
-      ! -------------------------------------------------------
-      zflageos = ( 0.5 + SIGN( 0.5, neos - 1. ) ) * rau0
-      DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-            zrhos          = rhop(ji,jj,1) + zflageos * ( 1. - tmask(ji,jj,1) )
-            zustar         = SQRT( taum(ji,jj) / ( zrhos +  rsmall ) )
-            ekm_dep(ji,jj) = rn_ekmfc * zustar / ( ABS( ff_t(ji,jj) ) + rsmall )
-            ekm_dep(ji,jj) = MAX(ekm_dep(ji,jj),rn_mldmin) ! Minimun allowed
-            ekm_dep(ji,jj) = MIN(ekm_dep(ji,jj),rn_mldmax) ! Maximum allowed
-         END DO
+            DO ji = 2, jpim1        !* Richardson number dependent coefficient
+               !                          ! shear of horizontal velocity
+               zsh2  =  ( zdu2(ji-1,jj) + zdu2(ji,jj) ) / MAX( 1._wp , umask(ji-1,jj,jk) + umask(ji,jj,jk) )   &
+                  &   + ( zdv2(ji,jj-1) + zdv2(ji,jj) ) / MAX( 1._wp , vmask(ji,jj-1,jk) + vmask(ji,jj,jk) )    
+               !                          ! coefficient = F(richardson number)
+               zcfRi = 1._wp / (  1._wp + rn_alp * MAX(  0._wp , avt(ji,jj,jk) * rn2(ji,jj,jk) / ( zsh2 + 1.e-20 ) )  )
+               !
+               !                    !* Vertical eddy viscosity and diffusivity coefficients
+               zav = rn_avmri * zcfRi**nn_ric
+               avm(ji,jj,jk) = MAX(  zav         , avmb(jk)  ) * wmask(ji,jj,jk)
+               avt(ji,jj,jk) = MAX(  zav * zcfRi , avtb(jk)  ) * wmask(ji,jj,jk)
+            END DO
+         END DO
+      ELSE                    !==  classical Richardson number definition  ==!
+         DO jj = 1, jpjm1           !* shear term
+            DO ji = 1, jpim1
+               zdu2(ji,jj) = 0.5 * (  un(ji,jj,jk-1) -  un(ji  ,jj,jk) )                         &
+                  &              * (  ub(ji,jj,jk-1) -  ub(ji  ,jj,jk) ) / (  e3uw_n(ji,jj,jk) * e3uw_b(ji,jj,jk) )
+               zdv2(ji,jj) = 0.5 * (  vn(ji,jj,jk-1) -  vn(ji,jj  ,jk) )                         &
+                  &              * (  vb(ji,jj,jk-1) -  vb(ji,jj  ,jk) ) / (  e3vw_n(ji,jj,jk) * e3vw_b(ji,jj,jk) )
+            END DO
+         END DO
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1        !* Richardson number dependent coefficient
+               !                          ! shear of horizontal velocity
+               zsh2  =  ( zdu2(ji-1,jj) + zdu2(ji,jj) ) / MAX( 1._wp , umask(ji-1,jj,jk) + umask(ji,jj,jk) )   &
+                  &   + ( zdv2(ji,jj-1) + zdv2(ji,jj) ) / MAX( 1._wp , vmask(ji,jj-1,jk) + vmask(ji,jj,jk) )    
+               !                          ! coefficient = F(richardson number)
+               zcfRi = 1._wp / (  1._wp + rn_alp * MAX(  0._wp , rn2(ji,jj,jk) / ( zsh2 + 1.e-20 ) )  )
+               !
+               !                    !* Vertical eddy viscosity and diffusivity coefficients
+               zav = rn_avmri * zcfRi**nn_ric
+               avm(ji,jj,jk) = MAX(  zav         , avmb(jk)  ) * wmask(ji,jj,jk)
+               avt(ji,jj,jk) = MAX(  zav * zcfRi , avtb(jk)  ) * wmask(ji,jj,jk)
+            END DO
+         END DO
+      ENDIF
+         !
       END DO
-
-      ! In the first model level vertical diff/visc coeff.s 
-      ! are always equal to the namelist values rn_wtmix/rn_wvmix
-      ! -------------------------------------------------------
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1
-            avmv(ji,jj,1) = MAX( avmv(ji,jj,1), rn_wvmix )
-            avmu(ji,jj,1) = MAX( avmu(ji,jj,1), rn_wvmix )
-            avt( ji,jj,1) = MAX(  avt(ji,jj,1), rn_wtmix )
-         END DO
-      END DO
-
-      !  Force the vertical mixing coef within the Ekman depth
-      ! -------------------------------------------------------
-      DO jk = 2, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-               IF( gdept_n(ji,jj,jk) < ekm_dep(ji,jj) ) THEN
-                  avmv(ji,jj,jk) = MAX( avmv(ji,jj,jk), rn_wvmix )
-                  avmu(ji,jj,jk) = MAX( avmu(ji,jj,jk), rn_wvmix )
-                  avt( ji,jj,jk) = MAX(  avt(ji,jj,jk), rn_wtmix )
-               ENDIF
-            END DO
-         END DO
-      END DO
-
-      DO jk = 1, jpkm1                
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-               avmv(ji,jj,jk) = avmv(ji,jj,jk) * vmask(ji,jj,jk)
-               avmu(ji,jj,jk) = avmu(ji,jj,jk) * umask(ji,jj,jk)
-               avt( ji,jj,jk) = avt( ji,jj,jk) * tmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-     ENDIF
-
-      CALL lbc_lnk( avt , 'W', 1. )                         ! Boundary conditions   (unchanged sign)
-      CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )
-      !
-      CALL wrk_dealloc( jpi,jpj, zwx, ekm_dep )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('zdf_ric')
+      !
+      IF( ln_mldw ) THEN      !==  set a minimum value in the Ekman layer  ==!
+         !
+         DO jj = 2, jpjm1        !* Ekman depth
+            DO ji = 2, jpim1
+               zustar = SQRT( taum(ji,jj) * r1_rau0 )
+               zh_ekm(ji,jj) = rn_ekmfc * zustar / ( ABS( ff_t(ji,jj) ) + rsmall )     ! Ekman depth
+               zh_ekm(ji,jj) = MAX(  rn_mldmin , MIN( zh_ekm(ji,jj) , rn_mldmax )  )   ! set allowed rang
+            END DO
+         END DO
+         DO jk = 2, jpkm1        !* minimum mixing coeff. within the Ekman layer
+            DO jj = 2, jpjm1
+               DO ji = 2, jpim1
+                  IF( gdept_n(ji,jj,jk) < zh_ekm(ji,jj) ) THEN
+                     avm(ji,jj,jk) = MAX(  avm(ji,jj,jk), rn_wvmix  ) * wmask(ji,jj,jk)
+                     avt(ji,jj,jk) = MAX(  avt(ji,jj,jk), rn_wtmix  ) * wmask(ji,jj,jk)
+                  ENDIF
+               END DO
+            END DO
+         END DO
+      END IF
+      !
+      IF( nn_timing == 1 )   CALL timing_stop('zdf_ric')
       !
    END SUBROUTINE zdf_ric
@@ -264,34 +224,19 @@
          WRITE(numout,*) 'zdf_ric : Ri depend vertical mixing scheme'
          WRITE(numout,*) '~~~~~~~'
-         WRITE(numout,*) '   Namelist namzdf_ric : set Kz(Ri) parameters'
-         WRITE(numout,*) '      maximum vertical viscosity     rn_avmri  = ', rn_avmri
-         WRITE(numout,*) '      coefficient                    rn_alp    = ', rn_alp
-         WRITE(numout,*) '      coefficient                    nn_ric    = ', nn_ric
-         WRITE(numout,*) '      Ekman Factor Coeff             rn_ekmfc  = ', rn_ekmfc
-         WRITE(numout,*) '      minimum mixed layer depth      rn_mldmin = ', rn_mldmin
-         WRITE(numout,*) '      maximum mixed layer depth      rn_mldmax = ', rn_mldmax
-         WRITE(numout,*) '      Vertical eddy Diff. in the ML  rn_wtmix  = ', rn_wtmix
-         WRITE(numout,*) '      Vertical eddy Visc. in the ML  rn_wvmix  = ', rn_wvmix
-         WRITE(numout,*) '      Use the MLD parameterization   ln_mldw   = ', ln_mldw
+         WRITE(numout,*) '   Namelist namzdf_ric : set Kz=F(Ri) parameters'
+         WRITE(numout,*) '      maximum vertical viscosity        rn_avmri  = ', rn_avmri
+         WRITE(numout,*) '      coefficient                       rn_alp    = ', rn_alp
+         WRITE(numout,*) '      exponent                          nn_ric    = ', nn_ric
+         WRITE(numout,*) '      Ekman layer enhanced mixing       ln_mldw   = ', ln_mldw
+         WRITE(numout,*) '         Ekman Factor Coeff             rn_ekmfc  = ', rn_ekmfc
+         WRITE(numout,*) '         minimum mixed layer depth      rn_mldmin = ', rn_mldmin
+         WRITE(numout,*) '         maximum mixed layer depth      rn_mldmax = ', rn_mldmax
+         WRITE(numout,*) '         Vertical eddy Diff. in the ML  rn_wtmix  = ', rn_wtmix
+         WRITE(numout,*) '         Vertical eddy Visc. in the ML  rn_wvmix  = ', rn_wvmix
       ENDIF
       !
-      !                              ! allocate zdfric arrays
-      IF( zdf_ric_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_ric_init : unable to allocate arrays' )
-      !
-      DO jk = 1, jpk                 ! weighting mean array tmric for 4 T-points
-         DO jj = 2, jpj              ! which accounts for coastal boundary conditions            
-            DO ji = 2, jpi
-               tmric(ji,jj,jk) =  tmask(ji,jj,jk)                                  &
-                  &            / MAX( 1.,  umask(ji-1,jj  ,jk) + umask(ji,jj,jk)   &
-                  &                      + vmask(ji  ,jj-1,jk) + vmask(ji,jj,jk)  )
-            END DO
-         END DO
-      END DO
-      tmric(:,1,:) = 0._wp
-      !
       DO jk = 1, jpk                 ! Initialization of vertical eddy coef. to the background value
-         avt (:,:,jk) = avtb(jk) * tmask(:,:,jk)
-         avmu(:,:,jk) = avmb(jk) * umask(:,:,jk)
-         avmv(:,:,jk) = avmb(jk) * vmask(:,:,jk)
+         avt(:,:,jk) = avtb(jk) * tmask(:,:,jk)
+         avm(:,:,jk) = avmb(jk) * umask(:,:,jk)
       END DO
       !
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfswm.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfswm.F90	(revision 7990)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfswm.F90	(revision 7990)
@@ -0,0 +1,95 @@
+MODULE zdfswm
+   !!======================================================================
+   !!                       ***  MODULE  zdfswm  ***
+   !! vertical physics :   surface wave-induced mixing 
+   !!======================================================================
+   !! History :  3.6  !  2014-10  (E. Clementi)  Original code
+   !!            4.0  !  2017-04  (G. Madec)  debug + simplifications
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   zdf_swm      : update Kz due to surface wave-induced mixing 
+   !!   zdf_swm_init : initilisation
+   !!----------------------------------------------------------------------
+   USE dom_oce        ! ocean domain variable
+   USE zdf_oce        ! vertical physics: mixing coefficients
+   USE sbc_oce        ! Surface boundary condition: ocean fields
+   USE sbcwave        ! wave module
+   !
+   USE in_out_manager ! I/O manager
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)  
+   USE lib_mpp        ! distribued memory computing library
+   
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC zdf_swm         ! routine called in zdp_phy
+   PUBLIC zdf_swm_init    ! routine called in zdf_phy_init
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017) 
+   !! $Id:$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE zdf_swm( kt )
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE zdf_swm ***
+      !!
+      !! ** Purpose :Compute the swm term (qbv) to be added to
+      !!             vertical viscosity and diffusivity coeffs.  
+      !!
+      !! ** Method  :   Compute the swm term Bv (zqb) and added it to
+      !!               vertical viscosity and diffusivity coefficients
+      !!                   zqb = alpha * A * Us(0) * exp (3 * k * z)
+      !!               where alpha is set here to 1
+      !!             
+      !! ** action  :    avt, avs, avm updated by the surface wave-induced mixing
+      !!                               (inner domain only)
+      !!               
+      !! reference : Qiao et al. GRL, 2004
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time step
+      !
+      INTEGER ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp)::   zcoef, zqb   ! local scalar
+      !!---------------------------------------------------------------------
+      !
+      zcoef = 1._wp * 0.353553_wp
+      DO jk = 2, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = 2, jpim1
+               zqb = zcoef * hsw(ji,jj) * tsd2d(ji,jj) * EXP( -3. * wnum(ji,jj) * gdepw_n(ji,jj,jk) ) * wmask(ji,jj,jk)
+               !
+               avt(ji,jj,jk) = avt(ji,jj,jk) + zqb
+               avs(ji,jj,jk) = avs(ji,jj,jk) + zqb
+               avm(ji,jj,jk) = avm(ji,jj,jk) + zqb
+            END DO
+         END DO
+      END DO
+      !
+   END SUBROUTINE zdf_swm
+   
+   
+   SUBROUTINE zdf_swm_init
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE zdf_swm_init ***
+      !!
+      !! ** Purpose :   surface wave-induced mixing initialisation  
+      !!
+      !! ** Method  :   check the availability of surface wave fields
+      !!---------------------------------------------------------------------
+      !
+      IF(lwp) THEN                  ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'zdf_swm_init : surface wave-driven mixing'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+      ENDIF
+      IF(  .NOT.ln_wave .OR.   &
+         & .NOT.ln_sdw    )   CALL ctl_stop ( 'zdf_swm_init: ln_zdfswm=T but ln_wave and ln_sdw /= T')
+      !
+   END SUBROUTINE zdf_swm_init
+
+   !!======================================================================
+END MODULE zdfswm
